> For the complete documentation index, see [llms.txt](https://docs.telemetry.sh/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.telemetry.sh/sdks/dart.md).

# Dart

*Disclaimer: This is a community-maintained package built by* [*Rohith Gilla*](https://x.com/gillarohith)*.*&#x20;

#### Installation

Install the package via dart pub:

```bash
dart pub add telemetry_sh
```

#### Usage

**Import the Library**

First, import the package into your Dart code:

```dart
import 'package:telemetry_sh/telemetry_sh.dart';
```

**Initialize the Client**

Next, initialize the `TelemetrySh` instance with your API key:

```dart
final telemetry = TelemetrySh('YOUR_API_KEY');  // Replace with your actual API key
```

**Log Some Data**

Telemetry automatically creates tables when data is logged. In this example, we log some Uber ride data to a table called `uber_rides`. Telemetry will automatically create this table and its corresponding schema with columns: `city`, `price`, and `timestamp`.

```dart
final data = {
  'city': 'paris',
  'price': 42,
  'timestamp': DateTime.now().toIso8601String()
};

Future<void> logData() async {
  try {
    final response = await telemetry.log('uber_rides', data);
    print('Log response: $response');
  } catch (error) {
    print('Error logging data: $error');
  }
}

logData();
```

**Query Some Data**

You can query the data using SQL through the query API:

```dart
final query = '''
  SELECT
    city,
    AVG(price) AS average_price
  FROM
    uber_rides
  GROUP BY
    city
''';

Future<void> queryData() async {
  try {
    final queryResponse = await telemetry.query(query);
    print('Query response: $queryResponse');
  } catch (error) {
    print('Error querying data: $error');
  }
}

queryData();
```


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.telemetry.sh/sdks/dart.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
